﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals

Dim Index2 As Int
Private texture As lgTexture
Dim Batch As lgSpriteBatch
Dim tilesize As Int = 64

Dim LeftWalk As lgAnimation
Dim RightWalk As lgAnimation
Dim pos As lgMathVector2

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()



texture.Initialize("actors/plane.png")
Dim Region As lgTextureRegion
Region.InitializeWithTexture(texture)
Dim WalkFrames(,) As lgTextureRegion = Region.Split(tilesize, tilesize)
Dim LeftWalkFrames() As lgTextureRegion = GetRegionArray(WalkFrames, 0)
Dim RightWalkFrames(LeftWalkFrames.Length) As lgTextureRegion
For i = 0 To RightWalkFrames.Length - 1
	Dim Frame As lgTextureRegion
	Frame.InitializeWithRegion(LeftWalkFrames(i))
	Frame.Flip(True, False)
	RightWalkFrames(i) = Frame
Next

'Initializes the animations
LeftWalk.Initialize(0.25, LeftWalkFrames)
RightWalk.Initialize(0.25, RightWalkFrames)


End Sub

Sub GetRegionArray(MultiDimArray As Object, Index As Int) As lgTextureRegion()
	Dim r As Reflector
	r.Target = MultiDimArray
	Return r.GetArray(Array As Int(Index))
End Sub

Sub plane_draw(camera As lgOrthographicCamera)

Batch.ProjectionMatrix = camera.Combined

Batch.Begin

	Dim Frame As lgTextureRegion
	Frame = LeftWalk.GetKeyFrame2( 0.5, True)
	Batch.DrawRegion(Frame, pos.x, pos.y)
	
Batch.End

End Sub
