﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals

	Private Maps As lgMapTiledMap
	Private MapRenderer As lgMapOrthogonalTiledMapRenderer
	Dim CurrentLayer As lgMapTiledMapLayer
	Dim MapWidth, MapHeight As Int 'in tiles
	Dim TileSize As Float 'in pixels
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Filename As String, Width As Int, Height As Int, GutterSize As Float)

loadmap(Filename)

	MapWidth = Maps.Properties.Get("width")
	MapHeight = Maps.Properties.Get("height")
	Log ("MapWidth:" & MapWidth)
	Log ("MapHeight:" & MapHeight)
	
	Dim TileWidth As Int = 20
	Dim TileHeight As Int = 20
	Dim RatioW As Float = Width / MapWidth
	
	Dim RatioH As Float = Height / MapHeight
	
	'Log("ratioW : "& RatioW )
	Log("ratioh : "& RatioH )
		If RatioW < RatioH Then
		MapRenderer.Initialize3(Maps, RatioH )
		TileSize = MapRenderer.UnitScale * TileWidth
	Else
		MapRenderer.Initialize3(Maps, RatioW )
		TileSize = MapRenderer.UnitScale * TileHeight
	End If

End Sub

'Each layer is a different maze
Public Sub SelectLayer(Layer As Int)
	CurrentLayer = Maps.Layers.Get(Layer)
End Sub

Public Sub FromTileToPixel_X(TileX As Int) As Int
	Return Round((TileX - 0.5) * TileSize)
End Sub

Public Sub FromTileToPixel_Y(TileY As Int) As Int
	Return Round((TileY - 0.5) * TileSize)
End Sub

Public Sub FromTileToPixel_InvertedY(TileY As Int) As Int
	Return Round((MapHeight - 1.5 - TileY) * TileSize)
End Sub

Public Sub FromPixelToTile_X(PixelX As Int) As Int
	Return Round((PixelX / TileSize) + 0.5)
End Sub

Public Sub FromPixelToTile_Y(PixelY As Int) As Int
	Return Round((PixelY / TileSize) + 0.5)
End Sub

'Gets the tile at the given coordinates
Public Sub GetTile(TileX As Int, TileY As Int) As lgMapStaticTiledMapTile
	Dim Cell As lgMapTiledMapLayerCell = CurrentLayer.GetCell(TileX, TileY)
	If Cell = Null Then
		Return Null
	Else
		Return Cell.Tile
	End If
End Sub

Private Sub loadmap(Filename As String)
	'Loads the mazes (TMX format)
	Dim TMXLoader As lgMapTmxMapLoader
	Maps = TMXLoader.Initialize2("maps/"& Filename )
End Sub

Public Sub Reload

	Maps.Dispose
	loadmap("naamloos.tmx")
	
	If MapRenderer.IsInitialized Then
		MapRenderer.Map= Maps
	Else
		MapRenderer.Initialize(Maps)
	End If

End Sub

'Draws the current layer
Public Sub Draw(Camera As lgOrthographicCamera)
	MapRenderer.SetCameraView(Camera)
	MapRenderer.Render()
	
End Sub

Public Sub Dispose
	Maps.Dispose
	MapRenderer.Dispose
End Sub
